Name:           trinity
Version:        1.8
Release:        2%{?dist}
Summary:        System call fuzz tester

License:        GPLv2
URL:            http://codemonkey.org.uk/projects/%{name}/
Source0:        http://codemonkey.org.uk/projects/%{name}/%{name}-%{version}.tar.xz
# Fix crash due to walking off the end of the net_protocols array
Patch0:         %{name}-net-protocols.patch
# Support autofs with and without AUTOFS_IOC_EXPIRE_(IN)DIRECT
Patch1:         %{name}-autofs.patch
# Do not redefine memfd_create
Patch2:         %{name}-memfd.patch

BuildRequires:  gcc

%description
Trinity makes syscalls at random, with random arguments.  Where Trinity
differs from other fuzz testers is that the arguments it passes are not
purely random.

We found some bugs in the past by just passing random values, but once
the really dumb bugs were found, these dumb fuzzers would just run and
run.  The problem was if a syscall took for example a file descriptor as
an argument, one of the first things it would try to do was validate
that fd.  Being garbage, the kernel would just reject it as -EINVAL of
course.  So on startup, Trinity creates a list of file descriptors, by
opening pipes, scanning sysfs, procfs, /dev, and creates a bunch of
sockets using random network protocols.  Then when a syscall needs an
fd, it gets passed one of these at random.

File descriptors aren't the only thing Trinity knows about.  Every
syscall has its arguments annotated, and where possible it tries to
provide something at least semi-sensible. "Length" arguments for example
get passed one of a whole bunch of potentially interesting values.
(Powers of 2 +/-1 are a good choice for triggering off-by-one bugs it
seems).

Trinity also shares those file descriptors between multiple threads,
which causes havoc sometimes.

If a child process successfully creates an mmap, the pointer is stored,
and fed to subsequent syscalls, sometimes with hilarious results.

%prep
%setup -q
%patch0
%patch1
%patch2

%build
./configure
make include/version.h
make %{?_smp_mflags} V=1 LDFLAGS="$RPM_LD_FLAGS" \
  CFLAGS="%{optflags} -I$PWD -I$PWD/include -D_GNU_SOURCE"

%install
# Install the main binary
make install DESTDIR=%{buildroot}%{_prefix}

# Install helper scripts
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -p scripts/* %{buildroot}%{_libexecdir}/%{name}
chmod a+x %{buildroot}%{_libexecdir}/%{name}/privs.sh

%files
%doc README Documentation/*
%license COPYING
%{_bindir}/%{name}
%{_libexecdir}/%{name}/

%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Nov 18 2017 Jerry James <loganjerry@gmail.com> - 1.8-1
- New upstream version
- Drop upstreamed -uio patch
- Add -net-protocols patch to fix bz 1514786
- Add -autofs patch to fix compilation under kernel 4.14+

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sat Oct 29 2016 Jerry James <loganjerry@gmail.com> - 1.7-1
- New upstream version

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Nov  3 2015 Jerry James <loganjerry@gmail.com> - 1.6-1
- New upstream version
- Drop upstreamed -termios patch
- Use license macro

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Mar 11 2015 Jerry James <loganjerry@gmail.com> - 1.5-1
- New upstream version

* Wed Sep  3 2014 Jerry James <loganjerry@gmail.com> - 1.4-4
- Add -termios patch to fix build failure (bz 1136442)

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon May 12 2014 Jerry James <loganjerry@gmail.com> - 1.4-1
- New upstream version

* Mon Jan 20 2014 Jerry James <loganjerry@gmail.com> - 1.3-1
- Initial RPM
